<!DOCTYPE html>
<meta name="viewport" content="width=device-width, initial-scale=1">
<html id="fullscreen">

<head>
    <title>Dashboard</title>

    <link rel='stylesheet' type="text/css" href='../css/meti_merged.css'>
    <script src='../js/meti_merged.js'></script>
    <script src='../js/meti_utils.js'></script>

    <style>
        .btn-group-xs>.btn,
        .btn-xs {
            padding: .25rem .4rem;
            font-size: .8rem;
            line-height: .8;
            border-radius: .2rem;
        }

        .card {
            border-width: 8px;
            border-color: white;
            border-radius: 30px !important;
        }

        .card-header {
            background: cornflowerblue;
            border-radius: 10px !important;
            padding-left: 5%;
            padding-right: 5%;
            padding-top: 2%;
            padding-bottom: 2%;
        }

        .card-text {
            font-family: Arial;
            height: 50%;
        }
    </style>
</head>


<body>
    <nav class="navbar navbar-expand-lg navbar-dark bg-primary pt-1 pb-1">
        <a class="navbar-brand" href="#">METI</a>
        <div>
            <h6 class="m-0" style="color:gold" ><span id="quickIot_title1">QuickIoT </span><span id="quickIot_title2"></span></h6>
            <label class="m-0" id="bs_device_id" style="font-size:0.65rem; color:white"></label>
        </div>

        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarsMeti"
            aria-controls="navbarsMeti" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>

        <div class="collapse navbar-collapse" id="navbarsMeti">
            <div class="col-8">
                <ul class="nav navbar-nav">
                    <li class="nav-item ml-2">
                        <a class="nav-link" href="/views/Dashboard.html"> Dashboard </a>
                    </li>
                </ul>
            </div>

            <div class="col-4">
                <ul class="nav navbar-nav justify-content-end">
                    <li class="nav-item dropdown">
                        <a class="nav-link dropdown-toggle" href="#" id="sel_row_items" data-toggle="dropdown"
                            aria-haspopup="true" aria-expanded="false"> Items in Row </a>
                        <div class="dropdown-menu" aria-labelledby="sel_row_items">
                            <a class="dropdown-item row_item" value="1">1</a>
                            <a class="dropdown-item row_item" value="2">2</a>
                            <a class="dropdown-item row_item" value="3">3</a>
                            <a class="dropdown-item row_item" value="4">4</a>
                            <a class="dropdown-item row_item" value="6">6</a>
                        </div>
                    </li>

                    <li class="nav-item">
                        <a class="nav-link" href="index.html"> Settings </a>
                    </li>
                </ul>
            </div>
        </div>
    </nav>

    <div id="no_drivers_used" class="ml-1">
        No Drivers selected/used/loaded...
    </div>

    <!-- cards -->
    <div class='ml-4 mr-4 mt-1 mb-1' id="my_card_deck">

    </div>

</body>

</html>

<script>
    // card font size...
    var layout_profiles = [
        {
            // 1
            'font_size': '975',
            'class': 'col-sm-12'
        },
        {
            // 2
            'font_size': '525',
            'class': 'col-sm-6'
        },
        {
            // 3
            'font_size': '375',
            'class': 'col-sm-4'
        },
        {
            // 4
            'font_size': '300',
            'class': 'col-sm-3'
        },
        {
            // 5
            'font_size': '220',
            'class': 'col-sm-2'
        },
        {
            // 6
            'font_size': '150',
            'class': 'col-sm-2'
        }]
</script>

<script>
    $(document).ready(function () {
        var sensors_per_row = 4;
        var sensor_list;
        var firstRun = true;

        setupDeviceSpecificLinks();

        $("#button_settings").on("click", function () {
            document.location.href = "SensorConfig.html";
        });

        $("#button_fs").on("click", function () {
            // var elem = document.getElementById("fullscreen");

            btn = $(this).val();
            if (btn == 0) {
                $(this).html('Exit full screen')
                    .removeClass('btn-success')
                    .addClass('btn-danger')
                    .val(1)
                openFullscreen();
            } else {
                $(this).html('Full screen')
                    .removeClass('btn-danger')
                    .addClass('btn-success')
                    .val(0)
                closeFullscreen();
            }
        });

        $(".row_item").on("click", function () {
            sensors_per_row = $(this).html();
            listSensors();
        });

        function listSensors() {
            // return;
            sensor_list = g_modbus_drivers.command.responseParser;

            //clear the deck
            $("#my_card_deck").html('');
            // var row_items = $("#sel_row_items").val();

            if (firstRun == true) {
                firstRun = false;

                totSensors = 0;
                $.each(sensor_list, function (idx, val) {
                    if (val.ac == true) {
                        if (val.di == true) {
                            totSensors++;
                        }
                    }
                });

                if (totSensors <= 4) {
                    sensors_per_row = 2;
                }
                else if (totSensors <= 6) {
                    sensors_per_row = 3;
                }
                else if (totSensors <= 8) {
                    sensors_per_row = 4;
                }
                else {
                    sensors_per_row = 6;
                }
            }

            var lp = layout_profiles[sensors_per_row - 1];

            var row_id = 0;
            var sensor_ctr = 0;

            // add cards to the deck from sensor list
            $.each(sensor_list, function (idx, val) {
                if (val.di == false) {
                    return true;  //if display is false, do not show sensor
                }
                if ((sensor_ctr % sensors_per_row) == 0 || sensor_ctr == 0) {
                    row_id = Math.floor(sensor_ctr / sensors_per_row) + 1;

                    var row = $('<div></div>')
                        .addClass('row')
                        .css('margin-top', '5px')
                        .attr("id", "row_" + row_id);

                    $("#my_card_deck").append(row)
                }

                fs = lp.font_size
                vfs = fs + "%";
                hfs = (fs / 2.7) + "%";

                var card = $('<div></div>')
                    .addClass("card text-white bg-primary")
                    .addClass(lp.class)

                var card_header = $('<div></div>')
                    .addClass("card-header")
                    .css('font-size', hfs)
                    .html(val.nm + ' (' + val.un + ')')

                // Narayan - value has to be changed to actual value
                var card_body = $('<div></div>')
                    .addClass("card-body text-right pt-1 pb-1 pl-0 pr-0")

                // Narayan - font size has to be dynamic??
                var card_text = $('<label></label>')
                    .addClass("card-text")
                    .css('font-size', vfs)
                    .attr('data-fs', fs)
                    .attr('id', idx)
                    .html('.');

                card_body.append(card_text);
                card.append(card_header).append(card_body);

                $("#row_" + row_id).append(card);
                sensor_ctr++;
            });
        }

        function updateSensorValues(response) {
            $.each(response, function (idx, val) {
                var finalVal = val.value;

                $('#' + idx)
                    .html(val.value)
                    .css("text-decoration", "")

                if (typeof finalVal !== "undefined") {
                    var finalValLen = finalVal.length;
                    if (finalValLen > 8) {
                        fs = $('#' + idx).data("fs");
                        fs = fs - (23 * (finalValLen - 8))
                        $('#' + idx)
                            .css('font-size', fs + "%");
                    }
                }

                if (val.error != 0) {
                    $('#' + idx)
                        .css("color", "dimgrey");
                } else {
                    $('#' + idx)
                        .css("color", "white");
                }
            });
        }

        function noSensorData(response) {
            // Narayan - handle this
            $(".card-text").each(function (idx, e) {
                $("#" + e.id).css("text-decoration", "line-through")
            });
        }

        function timerUpdateValues() {
            timer1 = setInterval(function () {
                getSensorValues(updateSensorValues, noSensorData);
            }, 3000);
        }

        function getActiveDriver() {
            g_currentDriver = '';

            var url = "/getActiveModbusDriver";
            if (LOCAL_HOST == true) {
                var url = "http://localhost/modbus/drivers/mmd_3.json";
            }

            var type = 'POST';
            var data = {
                app_key: "quickIoT"
            };

            // $("#loader_driver").css("display", "block");

            $.ajax({
                url: url,
                type: type,
                data: data,
                success: function (response) {
                    g_modbus_drivers = response;

                    if (typeof g_modbus_drivers.result === "undefined") {
                        $("#no_drivers_used").css("display", "none");
                        // if proper driver response, list sensors
                        listSensors();
                    } else {
                        $("#no_drivers_used").css("display", "block");
                        alert.log(response.message);
                    }
                },
                error: function (jqXHR, exception, response) {
                    $("#loader_driver").css("display", "none");
                    alert('POST Error!! Unable to get selected driver...');
                }
            });
        }
        //********* Call all start up functions after this line *******//
        // Narayan this has to be changed (dynamic driver id)
        setTimeout(function () {
            getActiveDriver();
            getSensorValues(updateSensorValues, noSensorData);
            timerUpdateValues();
        }, 500);
    });
</script>

<script>
    var elem = document.documentElement;
    function openFullscreen() {
        if (elem.requestFullscreen) {
            elem.requestFullscreen();
        } else if (elem.mozRequestFullScreen) { /* Firefox */
            elem.mozRequestFullScreen();
        } else if (elem.webkitRequestFullscreen) { /* Chrome, Safari & Opera */
            elem.webkitRequestFullscreen();
        } else if (elem.msRequestFullscreen) { /* IE/Edge */
            elem.msRequestFullscreen();
        }
    }

    function closeFullscreen() {
        if (document.exitFullscreen) {
            document.exitFullscreen();
        } else if (document.mozCancelFullScreen) {
            document.mozCancelFullScreen();
        } else if (document.webkitExitFullscreen) {
            document.webkitExitFullscreen();
        } else if (document.msExitFullscreen) {
            document.msExitFullscreen();
        }
    }
</script>